/***********************************************************
Gmail
***********************************************************/
function initHandler4(handler){
  var inboxOnly=handler.webMailNotifier.prefBranch.getBoolPref("webmail4.inboxOnly");
  handler.queryString="is%3Aunread"+(inboxOnly?"%20in%3Ainbox":"");
  handler.dataURL="http://mail.google.com/mail/?view=tl&search=query&start=0&q="+handler.queryString;
  handler.loginData=["https://www.google.com/accounts/LoginAuth?continue=http%3A%2F%2Fwww.google.com%2Fwebhp",
                      "Email","Passwd",
                      "continue=http%3A%2F%2Fmail.google.com%2Fwebhp&rmShown=1"];
  handler.mailURL="https://mail.google.com/mail";

  handler.process=function (aHttpChannel, aData) {
    switch(this.stage){
    case ST_LOGIN_RES:
      var fnd=aData.match(/<meta.+?url='(\S+)'/);
      if(fnd){
        fnd=fnd[1].replace(/&amp;/g,"&");
        this.webMailNotifier.getHtml(this,fnd);
        return false;
      }
    case (ST_LOGIN_RES+1):
      this.webMailNotifier.getHtml(this,"http://mail.google.com/mail");
      return false;
    case (ST_LOGIN_RES+2):
      var fnd=aData.match(/<meta.+?url='*(\S+)'*\"/i);
      if(fnd){
        fnd=fnd[1].replace(/&amp;/g,"&");
        this.webMailNotifier.getHtml(this,fnd);
        return false;
      }
    case (ST_LOGIN_RES+3):
      var fnd=aData.match(/ID_KEY\s*?:\s*?\'(.+?)\'/);
      if(fnd){
        this.dataURL="http://mail.google.com/mail/?ui=2&ik="+fnd[1]+"&view=tl&start=0&num=25&rt=h&q="+this.queryString+"&search=query";
        this.newUI=true;
      }else this.newUI=false;
      this.stage=ST_DATA;
      break;
    }
    return WebMailHandler.prototype.process.call(this,aHttpChannel, aData);
  };
  handler.getData=function(aData){
    var fnd;
    if(this.newUI)fnd=aData.match(/D\(\["ti",.+?,\d*,\d*,(\d+)/);
    else fnd=aData.match(/D\(\["ts",\d*,\d*,(\d+)/);
    if(fnd){
      return fnd[1];
    }else{
      return -1;
    }
  };
}
